/*
 * The POG project
 * Copyright 2000 The POG project team
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 */


#include "config.h"

// function sincos() for non-borland compilers
// #define HAVE_SINCOS should never be in config.h
#if defined(WANT_SINCOS) && !defined(HAVE_SINCOS)
# define HAVE_SINCOS
# ifdef BORLANDLIB
#  include <fastmath.h>
# else
void sincos(double x, double *s, double *c);
# endif
#endif



// NOTHROW incompatibility
#if defined(WANT_NOTHROW) && !defined(HAVE_NOTHROW)
#define HAVE_NOTHROW

# ifdef VISUAL_CPP
typedef struct {} nothrow_t;
extern nothrow_t nothrow;
inline void* operator new(unsigned int sizet, const nothrow_t&) throw()
{
	return operator new(sizet);
}
inline void operator delete(void* p, const nothrow_t&) throw()
{
	operator delete(p);
}
# endif
#endif



// vsnprintf() absence
#if  defined(WANT_VSNPRINTF) && !defined(HAVE_VSNPRINTF)
# define HAVE_VSNPRINTF
# ifdef VISUAL_CPP
#  define vsnprintf(b,bs,s,l) _vsnprintf(b,bs,s,l)
# endif
#endif



// chdir() absence
// #define HAVE_CHDIR should never be in config.h
#if defined(WANT_CHDIR) && !defined(HAVE_CHDIR)
# ifdef VISUAL_CPP
#  define HAVE_CHDIR
#  include <direct.h>
#  define chdir(S) _chdir(S)
# endif
# ifdef UNIX
#  include <unistd.h>
# endif
# ifdef BORLANDLIB
#  include <dir.h>
# endif
#define HAVE_CHDIR
#endif


#if defined(WANT_STRDUP) && !defined(HAVE_STRDUP)
#define HAVE_STRDUP
char *strdup(const char *s);
#endif /* WANT_STRDUP */


#if defined(WANT_MEMSET) || defined(WANT_MEMCPY)
# ifdef WINDOZE
#  ifdef VISUAL_CPP
#   include <memory.h>
#  else
#   include <mem.h>
#  endif
# endif
# ifdef UNIX
#  include <string.h>
# endif
#endif


#if defined(WANT_STRLWR) && !defined(HAVE_STRLWR)
#define HAVE_STRLWR
void strlwr(char *s);
#endif


#if defined(WANT_DISABLE_MATH_EXCEPTIONS) && !defined(HAVE_DISABLE_MATH_EXCEPTIONS)
# define HAVE_DISABLE_MATH_EXCEPTIONS
# ifdef BORLANDLIB
void Disable8087Exceptions(void);
void Enable8087Exceptions(void);
# else
inline void Disable8087Exceptions(void)  {};
inline void Enable8087Exceptions(void)  {};
# endif
#endif


#ifdef __linux__

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef WANT_VSNPRINTF
#ifdef HAVE_VSNPRINTF
#include <stdarg.h>
int vsnprintf(char *str, size_t n, const char *format, va_list ap);
#else  /* not def HAVE_VSNPRINTF */
#define vsnprintf(str, n, format, ap) vsprintf(str, format, ap)
#endif /* HAVE_VSNPRINTF */
#endif /* WANT_VSNPRINTF */

#endif

//#endif /* _porting_h_ */




